package adaptools.tools.adapmap;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JDesktopPane;

import adapmap.gui.action.Compile;
import adapmap.gui.frame.Editor;
import adapmap.gui.toolsbar.ButtonVectorGeneratorDefaultImpl;
import adaptools.vm.Viewer;

public class ButtonVectorGeneratorGui extends ButtonVectorGeneratorDefaultImpl {

	private JDesktopPane desktop;
	private Viewer viewer;
	
	
	public ButtonVectorGeneratorGui(Editor editor, Editor resposta, Viewer viewer) {
		super(editor, resposta);
		
		this.viewer = viewer;
		this.desktop = viewer.getTheDesktop();
	}
	
	
	public boolean createVectorOfActions() {
		
		super.createVectorOfActions();	
		
		//sobrescrevendo a acao do BotaoNew
		ActionVetor[0] = new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				AdapMapGui compileGui = new AdapMapGui(Viewer.ADAPMAP_NAME, true, true, true, true, viewer);				
				desktop.add(compileGui);
				compileGui.setSize(Viewer.CODE_WINDOW_SIZE_X, Viewer.CODE_WINDOW_SIZE_Y);
				compileGui.setLocation(Viewer.CODE_WINDOW_UP_X, Viewer.CODE_WINDOW_UP_Y);
				compileGui.setVisible(true);
				//compileGui.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
			}	
		};
		
		// sobrescrevendo a acao do BotaoCompile
		ActionVetor[3] = new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				new Compile(editor, resposta);
				
				if(!editor.isErroCompile()){
					File file = new File(editor.getStringName()+".spa");
					viewer.jMenuOpenObjectCodeActionPerformed(e, file);
				}
			}	
		};
		
		return false;	
	}

}
