/**
 * 
 */
package adaptools.utils;

import java.util.Hashtable;
import java.util.List;
import java.util.logging.Logger;

/**
 *  This class contain a data struct used to shared automata
 *transition when that are on AdapTools format.
 *
 * @author Denys G. Santos
 */
public class AdpSharedDataStruct {

	/** HashTable to shared the transitions table*/
	private Hashtable hash = new Hashtable();
	
	/**
	 * Shared the set transition.  
	 * @param List
	 */
	public void setCommonTransitions(List list){
	   
	   Object adp = null;
	   
	   //certifys if all list's components is instance of AdpDataStruct   
	   for(int i = 0; i < list.size(); i++){
		   adp = list.get(i);
		   if(!(adp instanceof AdpDataStruct)){
			   Logger logger = null;
			   logger.info("Sorry, but your list is not right\n" +
			   		"certify if all components' list is an instance of " +
			   		"AdpDataStruct");
			   return;
		   }
	   }
	   
	   AdpDataStruct component = (AdpDataStruct) list.get(0); 
	   hash.put(component.getOrig(), list);
		   
	}
	
	/**
	 * Get a Transitions List that have a same initial 
	 * state.
	 * @param String
	 * @return List
	 */
	public List getCommonTransitions(String key){
		
		return (List) hash.get(key);
	}
	
	
}
