package adaptools.utils;

import java.io.File;
import java.net.URI;
import java.util.ArrayList;
import java.util.List;

import adaptools.vm.Semantics;

public class ListSemanticsActions {

	private List semanticsAvailable;
	private LoadClass load = new LoadClass();
	
	public List getSemanticsAvailable(){
		semanticsAvailable = new ArrayList();
		
		// faz busca por classes com aes semanticas disponiveis
		ListClassesSemantics(ListFilesSubs.doGetDir()+"semantics/");
		
		return semanticsAvailable;
	}
	
	/**
     * Lista o Diretrio padro procurando por classes que implementam aes Semanticas
     *
     */
    private void ListClassesSemantics(String directory){
    	
    	File[] files;
    	
    	/* Faz chamada recursiva para todos os subdiretrios*/
    	files = ListFilesSubs.doFileFilterDirectoryListing(directory);
    	for(int i=0 ; i < files.length ; i++)
    		ListClassesSemantics(files[i].getAbsolutePath());
    	
    	// Recupera os arquivos com extenso class
    	files = ListFilesSubs.doFileFilterListing(directory,".*[.]class");
    	
    	
    	
    	for(int i=0 ; i< files.length ; i++ ){
    		try {
    			// recupera o caminho absoluto da classe    			
    			URI uri = files[i].toURI();
    			String nameClass = uri.getPath(); // transformei em uri para funcionar no Windows e Linux
    			
    			
    			nameClass = nameClass.replaceAll(ListFilesSubs.doGetDir(),"");
    			
    			nameClass = nameClass.replaceAll("[.]class","");
    			
    			nameClass = nameClass.replaceAll("[/]",".");
    			nameClass = nameClass.replaceFirst("semantics[.]","");
    	
    			//System.out.println(ListFilesSubs.doGetDir()+" classe = "+nameClass);
    			
    			Class testSemantic = load.loadClass(nameClass);

				//Class testSemantic = Class.forName(nameClass);
				
				// verifica se a classe  uma implemtao de Semantics
				// se for adiciona a lista de aes Semanticas Disponveis				 
				if(isInterface(testSemantic.getInterfaces(), Semantics.class)) {
					semanticsAvailable.add(nameClass);
					System.out.println(ListFilesSubs.doGetDir()+" classe = "+nameClass);
				}
					
			} catch (ClassNotFoundException e) {				
				e.printStackTrace();
			}
    	}
    }
    
    
    private boolean isInterface(Class[] interfaces, Class interf){
    	for(int i=0 ; i < interfaces.length ; i++)
    		if(interfaces[i].getName().equals(interf.getName()))
    			return true;
    		
    	return false; 
    }
    
}
