/** Token.java


 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 @author Hemerson Pistori (pistori@ec.ucdb.br)

 This work is based on Dr. Joao Jose Neto theories and techniques on
 Automata and Formal Languages (http://www.pcs.usp.br/~lta).


*/

package adaptools.vm;


/**

 A pair composed of a string label and a string value. Tokens are
 interchanged between different machines (a parser and a lexer, for instance)
 and from a {@link Vmds}, a virtual machine ({@link Kernel},{@link Adapter})
 and the class implementing the semantics of a virtual machine ({@link Semantics}).

 @author Hemerson Pistori (pistori@ec.ucdb.br)

*/
public class Token extends Object  {

    public String label;
    public String value;

    public Token(String label, String value) {
		this.label = label;
		this.value = value;
    }

}
